﻿' This project uses SciLexer.Net
' Documentation can be found at ...
'    http://scintillanet.codeplex.com/wikipage?title=ScintillaNET%20Types&referringTitle=Documentation
' To send text to the control use: 
' 
' 
Public Class Form1
    ' This is where Test.Xlm and other files are written
    ' Note that you will need "FULL RIGHTS" for the target directory
    ' The command line option for this is: -Work:"C:\My work Directory\Path\"
    Dim WorkDir As String = "C:\ScintillaNET\"

    ' This Wild Goose chase began because I wanted to use scintillanet for an application
    ' that uses SQLiteNet. I found that I need to create a XLM file for SQLite so that I 
    ' specify the keywords. If you are trying to create a new XLM language file then you
    ' can change the name here to load and test it. It will be added  to the END of the 
    ' ComboBox language list. 
    ' The command line option for this is: -Lang:"NewLangName"
    Dim NewLangName As String = "SQLite"

    ' If you do not like my choice of Fonts then you can change it here
    ' The command line option for this is: "-Font:"Arial"
    Dim FnameDefault As String = "Arial" ' "Consolas"
    Dim ColNumb As Integer      ' used to count columns in style list view



    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' Do this here to avoid extra processing
        ListView1.Visible = False

        ' Determine our working directory ....
        Dim Str As String = ""
        Dim StrTst As String = ""
        If Dir(WorkDir & "*.*") = "" Then
            WorkDir = CurDir()
        End If


        For Each S As String In My.Application.CommandLineArgs
            If InStr(S, "-Work:", CompareMethod.Text) = 1 Then
                WorkDir = Trim(Mid(S, 7))
            End If
            If InStr(S, "-Lang:", CompareMethod.Text) = 1 Then
                NewLangName = Trim(Mid(S, 7))
            End If
            If InStr(S, "-Font:", CompareMethod.Text) = 1 Then
                FnameDefault = Trim(Mid(S, 7))
            End If
            If InStr(S, "?") > 0 Then
                S = "Command Line options are:" & vbCrLf & _
                  "-work: is the working directory." & vbCrLf & _
                  "   New files are written here." & vbCrLf & _
                  "   You need full rights to this directory." & vbCrLf & _
                  "   The default is C:\ScintillaNET\ or the current directory." & vbCrLf & _
                  "-Lang: is the new ScintillaNET language file." & vbCrLf & _
                  "   The default is SQLite." & vbCrLf & _
                  "-Font: is the default font name for the Scintilla control." & vbCrLf & _
                  "   The default is Arial." & vbCrLf & _
                  "?  anywhere displays this message box." & vbCrLf & _
                  "Note that you need to enclose the option in Quotes" & vbCrLf & _
                  "if that are any spaces in the option." & vbCrLf & _
                  "The program will End/Exit when you close this Message box." & vbCrLf & vbCrLf & _
                  "Example:" & vbCrLf & _
                  "   -work:C:\ScintillaNET\ -Lang:Sqlite -Font:Arial" & vbCrLf & vbCrLf & _
                  Application.ProductName & vbCrLf & _
                  "This program is placed in the PUBLIC DOMAIN" & vbCrLf & _
                  "by: Lewis Balentine, www.keywild.com" & vbCrLf & _
                  "November 2013"
                MsgBox(S)
                End
            End If
        Next

        If Microsoft.VisualBasic.Right(WorkDir, 1) <> "\" Then WorkDir = WorkDir & "\"
        Me.Text = Application.ProductName & "      " & WorkDir

        ' Do we have user supplied generic text for testing ???
        StrTst = WorkDir & "SandBox_TestText.txt"
        If Dir(StrTst) <> "" Then Str = (My.Computer.FileSystem.ReadAllText(StrTst))
        If Str <> "" Then StrTst = WorkDir & "XML\" & "SandBox_TestText.txt"
        If Dir(StrTst) <> "" Then Str = (My.Computer.FileSystem.ReadAllText(StrTst))
        If Str = "" Then
            Str = "1234567890 () [] {} <>  / \ + - *  = & @ # $ % ^ ! ? # ~ |" & vbCrLf & _
                  "ABCDEF GHIJKLM " & Chr(34) & _
                  "Double quoted string" & Chr(34) & "  'Single Quoted String'  " & vbCrLf & vbCrLf & _
                  "Select ROWID, Bogus, count(child) as Children," & _
                  " *  from [Employees] where [Name] like '%DOE%' group by state limit 0,100;" & vbCrLf & vbCrLf & _
                  "CREATE TABLE NewTable (x INTEGER, y, z, PRIMARY KEY(x ASC));" & vbCrLf & vbCrLf & _
                  "int cFunction ( int x, int y) { return x * y;} " & vbCrLf & vbCrLf & _
                  "PRAGMA ignore_check_constraints;  -- SQL comment" & vbCrLf & vbCrLf & _
                  "/* This is a comment for some SQL system as well as the C language */" & vbCrLf & _
                  "<!-- just to be fair we have a HTML comment in as well -->" & vbCrLf & _
                  "; Ini files and some others use semicolons for comment lines" & vbCrLf & _
                  "# some language use a hash sign for comment lines" & vbCrLf & _
                  "/' Freebasic supports block comments '/ " & vbCrLf & _
                  "Basic_Line_Label: ' Most basic use single quote for comments.  "
        End If
        Scintilla1.Text = Str

        ' Fill up our built in languages
        ComboBox1.Items.Clear()
        Dim Languages() As String = [Enum].GetNames(GetType(ScintillaNET.Lexer))
        Array.Sort(Languages)
        For Each Lang In Languages
            ComboBox1.Items.Add(Lang)
            ' check for an XML version
            AddLamguageXML(Lang)
        Next
        ' add some XML language files
        AddLamguageXML("arduino")
        AddLamguageXML("js")
        AddLamguageXML("mssql")
        AddLamguageXML("pgsql")
        AddLamguageXML("vbscript")
        AddLamguageXML("xml")
        AddLamguageXML(NewLangName)
        ComboBox1.SelectedIndex = 0
        ' UpdateLaguage() ' not needed

        ' Align the controls
        ListView1.Left = Scintilla1.Left
        ListView1.Top = Scintilla1.Top

        ' Turn off a bunch of stuff we do not want display untill it is needed

        
        ' Set some other defaults
        chkLineWrap.Checked = True
        Scintilla1.LineWrapping.Mode = ScintillaNET.LineWrappingMode.Word
        chkLineNumbers.Checked = True
        Scintilla1.Margins(0).Width = 30

    End Sub
    Sub AddLamguageXML(Lang As String)
        Dim Tst As String
        Tst = WorkDir & "XML\" & Lang & ".xml"
        If Dir(Tst) <> "" Then ComboBox1.Items.Add("XML: " & Lang)
        ' Note the change in case.
        Tst = WorkDir & Lang & ".xml"
        If Dir(Tst) <> "" Then ComboBox1.Items.Add("xml: " & Lang)
    End Sub
    Sub UpdateLaguage()
        LabelLanguage.Text = "Language: " & Scintilla1.ConfigurationManager.Language
        LabelLexer.Text = "Lexer: " & Scintilla1.Lexing.LexerName & " (" & Scintilla1.NativeInterface.GetLexer.ToString & ")"
    End Sub
    Private Sub Button8_Click(sender As System.Object, e As System.EventArgs) Handles Button8.Click
        ' Writing language specific style list
        ' First determine the target directory ...
        Dim TargetDir As String = WorkDir & "XML\"
        Dim T, S, TabStr, Lang As String
        Dim J, N As Integer

        If Dir(TargetDir & "*.*") = "" Then TargetDir = WorkDir 'revert
        ' Second get the target Language (Lexer)
        Lang = Scintilla1.Lexing.LexerName
        Dim TargetFile As String = TargetDir & Lang & "(" & Scintilla1.NativeInterface.GetLexer.ToString & ")-styles.xml"

        T = "<?xml version=" & QStr("1.0") & " encoding=" & QStr("utf-8") & "?>" & vbCrLf
        T = T & "<!-- These are all of the styles ScintillaNet Lexer:" & QStr(Lang) & " -->" & vbCrLf
        T = T & "<!-- The Scintilla.dll uses a Lexer number:" & QStr(Scintilla1.NativeInterface.GetLexer.ToString) & " -->" & vbCrLf
        T = T & "<!-- The same Scintilla.dll internal lexer may be used for several ScintillaNet languages. -->" & vbCrLf
        T = T & "<!-- The styles with a dot '.' in the name are skipped because they are inherited. -->" & vbCrLf
        T = T & "<!-- ALL attributes (except font name, size and chr set) have been filled in. -->" & vbCrLf
        T = T & "<!-- ScintillaNet Sandbox by: Lewis Balentine, www.keywild.com -->" & vbCrLf
        T = T & "<ScintillaNET>" & vbCrLf
        T = T & vbTab & "<Language Name=" & QStr(Lang) & " >" & vbCrLf
        T = T & vbTab & vbTab & "<Styles>" & vbCrLf

        My.Computer.FileSystem.WriteAllText(TargetFile, T, False, System.Text.Encoding.UTF8)
        ' as an added feature we build a tab delimited string for the clipboard
        TabStr = Lang & vbCrLf & _
                 "Style No" & vbTab & "Style Name" & vbTab & "Note" & vbTab & "Sample" & vbTab & "BackGround" & vbTab & "ForeGround" & vbTab & _
                 "Bold" & vbTab & "Italic" & vbTab & "UnderLine" & vbTab & "Eol Fill" & vbCrLf

        N = Scintilla1.Lexing.StyleNameMap.Count
        For J = 0 To N - 1
            S = Scintilla1.Lexing.StyleNameMap.Keys(J).ToString
            If InStr(S, ".") = 0 Then
                S = ""
                My.Computer.FileSystem.WriteAllText(TargetFile, vbTab & vbTab & vbTab & CreatStyleLine(J, S) & vbCrLf, True, System.Text.Encoding.UTF8)
                TabStr = TabStr & S & vbCrLf
            End If
        Next
        My.Computer.Clipboard.SetText(TabStr)
        T = vbTab & vbTab & "</Styles>" & vbCrLf
        T = T & vbTab & "</Language>" & vbCrLf
        T = T & "</ScintillaNET>" & vbCrLf
        My.Computer.FileSystem.WriteAllText(TargetFile, T, True, System.Text.Encoding.UTF8)


    End Sub

    Private Sub Form1_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
        Scintilla1.Width = Me.Width - 10        ' the ONLY way to get these number correct is to set them at design time
        Scintilla1.Height = Me.Height - 120     ' by calculating them from the control and form properties
        ListView1.Width = Scintilla1.Width
        ListView1.Height = Scintilla1.Height
    End Sub

    Private Sub chkLineWrap_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkLineWrap.CheckedChanged
        If (chkLineWrap.Checked) Then
            Scintilla1.LineWrapping.Mode = ScintillaNET.LineWrappingMode.Word
        Else
            Scintilla1.LineWrapping.Mode = ScintillaNET.LineWrappingMode.None
        End If

    End Sub

    Private Sub chkLineNumbers_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkLineNumbers.CheckedChanged
        If (chkLineNumbers.Checked) Then
            Scintilla1.Margins(0).Width = 30
        Else
            Scintilla1.Margins(0).Width = 0
        End If

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        ShowStyles()
    End Sub

    Private Sub ShowStyles()
        ' Toggles Style Window
        Dim I, N, K, V As Integer
        If ListView1.Visible Then
            'LabelLexer.Visible = False
            'LabelLanguage.Visible = False
            LabelStyles.Visible = False
            ListView1.Visible = False
            Scintilla1.Visible = True
            Button1.Text = "Show Styles"
        Else
            If TextBox1.Text <> "" Then
                V = Val(TextBox1.Text)
            Else
                V = -1
            End If

            'LabelLanguage.Text = "Language: " & Scintilla1.ConfigurationManager.Language
            'LabelLexer.Text = "Lexer: " & Scintilla1.Lexing.LexerName & " (" & Scintilla1.NativeInterface.GetLexer.ToString & ")"
            N = Scintilla1.Lexing.StyleNameMap.Count
            LabelStyles.Text = "Styles: " & Str(N)
            'initalize listview
            ' Set the initial sorting type for the ListView.
            Me.ListView1.Clear()
            Me.ListView1.Columns.Clear()
            Me.ListView1.View = View.Details
            Me.ListView1.Sorting = SortOrder.None
            ' Add columns Headers and set their text.
            ColNumb = 0
            SetColHeader("Name", 50)
            SetColHeader("Used As", 150)
            SetColHeader("Example", 100)
            SetColHeader("Font", 60)
            SetColHeader("CharacterSet", 75)
            SetColHeader("Size", 40)
            SetColHeader("Bold", 50)
            SetColHeader("Italic", 50)
            SetColHeader("UnderLine", 50)
            SetColHeader("Case", 50)
            SetColHeader("Background", 80)
            SetColHeader("Foreground", 80)
            SetColHeader("Visible", 80)
            SetColHeader("Eol Filled", 100)

            ' add items
            For I = 0 To N - 1
                K = Val(Scintilla1.Lexing.StyleNameMap.Values(I).ToString)
                ' Style Number and Name
                K = Val(Scintilla1.Lexing.StyleNameMap.Values(I).ToString)
                Dim listViewItem1 As New ListViewItem(New String() { _
                    Scintilla1.Styles(K).ToString, _
                    Scintilla1.Lexing.StyleNameMap.Keys(I).ToString, _
                    "(ABC123abc}", _
                    Scintilla1.Styles(K).FontName.ToString, _
                    Scintilla1.Styles(K).CharacterSet.ToString, _
                    Scintilla1.Styles(K).Size.ToString, _
                    Scintilla1.Styles(K).Bold.ToString, _
                    Scintilla1.Styles(K).Italic.ToString, _
                    Scintilla1.Styles(K).Underline.ToString, _
                    Scintilla1.Styles(K).Case.ToString, _
                    RtnColorStr(K, 1), _
                    RtnColorStr(K, 0), _
                    Scintilla1.Styles(K).IsVisible.ToString, _
                    Scintilla1.Styles(K).IsSelectionEolFilled.ToString()
                    })
                listViewItem1.UseItemStyleForSubItems = False
                listViewItem1.SubItems(2).Font = Scintilla1.Styles(K).Font
                listViewItem1.SubItems(2).BackColor = Scintilla1.Styles(K).BackColor
                listViewItem1.SubItems(2).ForeColor = Scintilla1.Styles(K).ForeColor
                If V = K Then listViewItem1.SubItems(0).BackColor = Color.Yellow
                Me.ListView1.Items.Add(listViewItem1)
            Next I
            LabelLanguage.Visible = True
            LabelLexer.Visible = True
            LabelStyles.Visible = True
            ListView1.Visible = True
            Scintilla1.Visible = False
            Button1.Text = "Hide Styles"
        End If
    End Sub

    Private Sub SetColHeader(Nm As String, Wd As Integer)
        Me.ListView1.Columns.Add(New ColumnHeader)
        Me.ListView1.Columns(ColNumb).Text = Nm
        Me.ListView1.Columns(ColNumb).Width = Wd
        ColNumb = ColNumb + 1
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Scintilla1.Commands.Execute(ScintillaNET.BindableCommand.ZoomIn)
    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        Scintilla1.Commands.Execute(ScintillaNET.BindableCommand.ZoomOut)
    End Sub

    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        ResetFonts()
    End Sub
    Private Sub ResetFonts()
        Static Dim BeenThereDoneThat As Boolean = True      ' reverse logic
        Dim I As Integer
        Dim Fsize As String = "10"
        ' Standards: Default
        Scintilla1.Styles(32).FontName = FnameDefault
        Scintilla1.Styles(32).Size = 10

        ' Standards: Line Numbers (I hate this font but it is the ONLY monospaced font Microsoft has.)
        Scintilla1.Styles(33).FontName = "Courier New"
        Scintilla1.Styles(33).Size = 9

        ' Standards: BraceLight
        Scintilla1.Styles(34).FontName = "Courier New"
        Scintilla1.Styles(34).Size = 9

        ' Standards: BraceBad
        Scintilla1.Styles(35).FontName = "Courier New"
        Scintilla1.Styles(35).Size = 9
        ' Standards: Control Character

        ' Standards: Control Character
        Scintilla1.Styles(36).FontName = "Courier New"
        Scintilla1.Styles(36).Size = 9

        ' Standards: 
        Scintilla1.Styles(37).FontName = "Courier New"
        Scintilla1.Styles(37).Size = 9

        ' Standards: CallTip
        Scintilla1.Styles(38).FontName = "Tahoma"
        Scintilla1.Styles(38).Size = 8.25


        ' Everything Else
        For I = 0 To 31
            Scintilla1.Styles(I).FontName = FnameDefault
            Scintilla1.Styles(I).Size = Fsize
        Next
        For I = 39 To 255
            Scintilla1.Styles(I).FontName = FnameDefault
            Scintilla1.Styles(I).Size = Fsize
        Next

        ' Now zoom in so we can see what is going on
        ' This is cumaltive. We only want to do it once.
        If BeenThereDoneThat Then
            Scintilla1.Commands.Execute(ScintillaNET.BindableCommand.ZoomIn)
            Scintilla1.Commands.Execute(ScintillaNET.BindableCommand.ZoomIn)
            Scintilla1.Commands.Execute(ScintillaNET.BindableCommand.ZoomIn)
            BeenThereDoneThat = False
        End If

    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SetLanguage()
    End Sub
    Sub SetLanguage()
        Dim T, Lang As String
        If ListView1.Visible Then ShowStyles()
        Lang = ComboBox1.Text
        If InStr(Lang, "xml:", CompareMethod.Text) = 1 Then
            ' this is a request for a XML file base language, split it
            T = Trim(Mid(Lang, 1, 3))
            Lang = Trim(Mid(Lang, 5))
            If T = "XML" Then
                ' it is in the XML subdirectory
                T = WorkDir & "XML\" ' & Lang & ".XML"
            Else
                ' it is in the work directory
                T = WorkDir ' & Lang & ".XML"
            End If
            ' Make sure that we did not screw up or
            ' that the file has not been erased, moved or renamed.
            If Dir(T & Lang & ".xml") = "" Then
                MsgBox("Unable to locate language file: " & T & Lang & ".xml")
            Else
                ' OK try to load it ....
                Scintilla1.ConfigurationManager.CustomLocation = T
                Scintilla1.ConfigurationManager.Language = Lang
                ' Do we have a special Text file to go with it ??
                ' & NewLangName & "_TestText.txt"
                If Dir(T & Lang & "_TestText.txt") <> "" Then
                    ' We are going to reuse the Lang String
                    Lang = ""
                    Lang = (My.Computer.FileSystem.ReadAllText(T & Lang & "_TestText.txt"))
                    If Lang <> "" Then
                        Scintilla1.Text = Lang
                    End If
                End If
                ' restore the configuration manager to normal 'Scintilla.dll internal' orperation after the file is loaded.
                Scintilla1.ConfigurationManager.CustomLocation = ""
                Button5.Enabled = False
            End If
        Else
            ' This is much simpler
            Scintilla1.ConfigurationManager.Language = Lang
            ' This should not be needed but just in case ....
            ' Scintilla1.Lexing.LexerName = Lang
            Button5.Enabled = True
        End If

        ' This was used for debugging ... I am leaving it here for the same reason.
        'Dim N As Integer
        'N = Scintilla1.NativeInterface.GetLexer
        'T = Scintilla1.ConfigurationManager.Language
        'T = T & ", " & Scintilla1.Lexing.LexerName & ", " & N.ToString
        'Dim B as Boolean Scintilla1.ConfigurationManager.IsBuiltInEnabled = False
        'MsgBox(T)

        TextBox1.Text = ""
        Label1.Text = ""
        LabelStyles.Visible = False
        UpdateLaguage()

    End Sub
    Private Sub Button5_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
        ' Load TEST.XML Language File
        ' sparce documentation at: http://scintillanet.codeplex.com/wikipage?title=HowToCustomConfig&referringTitle=Documentation
        ' Using ConfigurationManager.Language + ConfigurationManager.CustomLocation to load your own configurations.

        Dim Lang As String = WriteTestXLM()
        If Lang = "" Then
            MsgBox("This function only supports Scintilla internal Lexers.")
        Else
            Scintilla1.ConfigurationManager.CustomLocation = Lang
            Scintilla1.ConfigurationManager.Language = "test"
            ' restore the configuration manager to normal 'Scintilla.dll internal' orperation after the file is loaded.
            Scintilla1.ConfigurationManager.CustomLocation = ""

            ' Check to see of our indicators are loaded
            If InStr(Scintilla1.Text, "list0") = 0 Then
                Scintilla1.Text = "list0" & vbCrLf & "list1" & vbCrLf & "list2" & vbCrLf & "list3" & vbCrLf & _
                                  "list4" & vbCrLf & "list5" & vbCrLf & "list6" & _
                                   vbCrLf & Scintilla1.Text
            End If
            MsgBox("test.XML file loaded")
            TextBox1.Text = ""
            Label1.Text = ""
            UpdateLaguage()
        End If

    End Sub
    Function WriteTestXLM() As String
        If InStr(ComboBox1.Text, "xml:", CompareMethod.Text) = 1 Then
            Return ""
        Else
            Dim I As Integer = 0
            ' First determine the target directory ...
            Dim TargetDir As String = WorkDir & "XML\"
            If Dir(TargetDir & "*.*") = "" Then TargetDir = WorkDir 'revert
            ' Second get the target Language (Lexer)
            Dim TargetFile As String = TargetDir & "test.xml"

            Dim Lang As String = ComboBox1.Text
            ' Construct the file
            Dim T As String = ""
            T = "<?xml version=" & QStr("1.0") & " encoding=" & QStr("utf-8") & " ?>" & vbCrLf
            T = T & "<!-- This is a minimal language configuration file for ScintillaNET -->" & vbCrLf
            T = T & "<!-- It is intended to be used to determine the styles used for each keyword list -->" & vbCrLf
            T = T & "<!-- For this to work the language and lexer names must be specified -->" & vbCrLf
            T = T & "<ScintillaNET>" & vbCrLf
            T = T & vbTab & "<Language Name=" & QStr("Test") & " >" & vbCrLf

            ' This is the ALL IMPORTENT Lexer line to start the language section 
            ' We are specifying "C" style comments because we have those embedded in the test code
            ' No, I do not know why the suffix has the order reversed (reverse logic ??).
            ' Actually I think it is doing a reverse stream search.
            T = T & vbTab & vbTab & "<Lexer LexerName=" & QStr(Lang) & " LineCommentPrefix=" & QStr(" /") & _
                    " StreamCommentPrefix=" & QStr("/* ") & " StreamCommentSuffix=" & QStr("/* ") & _
                    " >" & vbCrLf

            ' Now we construct a section for each keyword list
            For I = 0 To 6
                T = T & vbTab & vbTab & vbTab & "<Keywords List=" & QStr(I.ToString) & " >" & vbCrLf
                T = T & vbTab & vbTab & vbTab & vbTab & "list" & I.ToString & vbCrLf
                T = T & vbTab & vbTab & vbTab & "</Keywords>" & vbCrLf
            Next
            T = T & vbTab & vbTab & "</Lexer>" & vbCrLf

            ' Minimal Style Section
            T = T & vbTab & vbTab & "<Styles>" & vbCrLf
            T = T & vbTab & vbTab & vbTab & "<Style Name=" & QStr("DEFAULT") & " FontName=" & QStr(FnameDefault) & " FontSize=" & QStr("10") & " />" & vbCrLf
            T = T & vbTab & vbTab & vbTab & "<Style Name=" & QStr("DOCUMMENT_DEFAULT") & " FontName=" & QStr(FnameDefault) & " FontSize=" & QStr("10") & " />" & vbCrLf
            T = T & vbTab & vbTab & "</Styles>" & vbCrLf
            ' lastly close the sections
            T = T & "</Language>" & vbCrLf
            T = T & "</ScintillaNET>"

            ' Now write the file and return the name
            My.Computer.FileSystem.WriteAllText(TargetFile, T, False, System.Text.Encoding.UTF8)
            Return TargetFile
        End If

    End Function

    Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
        ' Writes ALL Languages to an XML file
        ' ScintillaNET uses Microsoft's XML reader. 
        ' This is not a non-fault tolerate piece of software.
        ' A single byte out of place anywhere will bring it crashing to its knees.
        '
        ' First determine the target directory ...
        ' Save the current language and lexer

        Dim TargetDir As String = WorkDir & "XML\"
        If Dir(TargetDir & "*.*") = "" Then TargetDir = WorkDir 'revert
        Dim TargetFile As String = TargetDir & "Languages-All.xml"

        Dim T As String = ""
        T = "<?xml version=" & QStr("1.0") & " encoding=" & QStr("utf-8") & " ?>" & vbCrLf
        T = T & "<!-- This is a minimal language configuration file for ScintillaNET -->" & vbCrLf
        T = T & "<!-- It is actually more of a list thatn a configuration file. -->" & vbCrLf
        T = T & "<!-- ScintillaNet Sandbox by: Lewis Balentine, www.keywild.com -->" & vbCrLf
        T = T & "<ScintillaNET>" & vbCrLf

        Dim Languages() As String = [Enum].GetNames(GetType(ScintillaNET.Lexer))
        Array.Sort(Languages)
        For Each Lang In Languages
            ' example minimal file
            '<?xml version="1.0" encoding="utf-8"?>
            '<!-- This is a minimal language configuration file for ScintillaNET -->
            '<ScintillaNET>
            '<Language Name="ada">
            '<Lexer LexerName="ada"/>	
            '</Language>
            '</ScintillaNET>
            T = T & vbTab & "<Language Name=" & QStr(Lang) & " >" & vbCrLf
            T = T & vbTab & vbTab & "<Lexer LexerName=" & QStr(Lang) & "/>" & vbCrLf
            T = T & vbTab & "</Language>" & vbCrLf & vbCrLf
        Next
        T = T & "</ScintillaNET>"
        ' It makes absolutely no differences which of these you use. The result is the same.
        ' My.Computer.FileSystem.WriteAllText(TargetFile, T, False, System.Text.Encoding.ASCII)
        My.Computer.FileSystem.WriteAllText(TargetFile, T, False, System.Text.Encoding.UTF8)
        ' Restore the Laguage and Lexer. We cheat by using ....
        SetLanguage()

    End Sub
    Private Sub Button6_Click(sender As System.Object, e As System.EventArgs) Handles Button6.Click
        WriteAllStyles()
    End Sub

    Private Sub WriteAllStyles()
        Dim J As Integer
        Dim H1, H2, H3, H4, T, S As String
        Dim N As Integer = 0
        H1 = "start_h1"
        H2 = "start_h2"
        H3 = "start_h3"
        H4 = "start_h4"

        ' First determine the target directory ...
        Dim TargetDir As String = WorkDir & "XML\"
        If Dir(TargetDir & "*.*") = "" Then TargetDir = WorkDir 'revert
        ' Second get the target Language (Lexer)
        Dim TargetFile As String = TargetDir & "DefaultStyles-All.xml"

        T = "<?xml version=" & QStr("1.0") & " encoding=" & QStr("utf-8") & "?>" & vbCrLf
        T = T & "<!-- These are all of the styles from ScintillaNet. -->" & vbCrLf
        T = T & "<!-- The first occurence of each style in Language order is used. -->" & vbCrLf
        T = T & "<!-- The ones with a dot '.' in the name because are skipped because they are inherited. -->" & vbCrLf
        T = T & "<!-- ALL attributes (except font name, size and chr set) have been filled in. -->" & vbCrLf
        T = T & "<!-- ScintillaNet Sandbox by: Lewis Balentine, www.keywild.com -->" & vbCrLf
        T = T & "<ScintillaNET>" & vbCrLf
        T = T & vbTab & "<Language Name=" & QStr("default") & " >" & vbCrLf
        T = T & vbTab & vbTab & "<Styles>" & vbCrLf
        My.Computer.FileSystem.WriteAllText(TargetFile, T, False, System.Text.Encoding.UTF8)

        Dim Languages() As String = [Enum].GetNames(GetType(ScintillaNET.Lexer))
        Array.Sort(Languages)
        For Each Lang In Languages
            Scintilla1.ConfigurationManager.Language = Lang
            N = Scintilla1.Lexing.StyleNameMap.Count
            For J = 0 To N - 1
                S = Scintilla1.Lexing.StyleNameMap.Keys(J).ToString
                ' We will only use the first occurence of each style
                If InStr(S, ".") = 0 Then
                    If InStr(H1, S) = 0 Then
                        H1 = H1 & ", " & S
                        My.Computer.FileSystem.WriteAllText(TargetFile, vbTab & vbTab & vbTab & CreatStyleLine(J) & vbCrLf, True, System.Text.Encoding.UTF8)
                    Else
                        ' The code below allows one to reduce the number of styles according to how often they are used.
                        ' You will allso need to comment out the higher level lines that write to the file.
                        '
                        'If InStr(H2, S) = 0 Then
                        'H2 = H2 & ", " & S
                        'My.Computer.FileSystem.WriteAllText(TargetFile, vbTab & vbTab & vbTab & CreatStyleLine(J) & vbCrLf, True, System.Text.Encoding.UTF8)
                        'Else
                        ''If InStr(H3, S) = 0 Then
                        ''H3 = H3 & ", " & S
                        ''My.Computer.FileSystem.WriteAllText(TargetFile, vbTab & vbTab & vbTab & CreatStyleLine(J) & vbCrLf, True, System.Text.Encoding.UTF8)
                        ''Else
                        ''If InStr(H4, S) = 0 Then
                        ''  H4 = H4 & ", " & S
                        ''   My.Computer.FileSystem.WriteAllText(TargetFile, vbTab & vbTab & vbTab & CreatStyleLine(J) & vbCrLf, True, System.Text.Encoding.UTF8)
                        '' End If
                        ''End If
                        'End If
                    End If
                End If
            Next
        Next
        T = vbTab & vbTab & "</Styles>" & vbCrLf
        T = T & vbTab & "</Language>" & vbCrLf
        T = T & "</ScintillaNET>" & vbCrLf
        My.Computer.FileSystem.WriteAllText(TargetFile, T, True, System.Text.Encoding.UTF8)
        ' Restore the Laguage and Lexer. We cheat by using ....
        SetLanguage()

    End Sub

    Private Function CreatStyleLine(J As Integer, Optional ByRef TabStr As String = "") As String
        ' Note: I have taken the Font Name and size out
        '       We are not getting what Scintilla.dll use as a default
        '       We are getting what ScintillaNet "thinks" the font is supposed to be.
        '       I note that Scite defaults to a non-serif variable space font.
        '       ScIde default to Courier New.
        '
        Dim K As Integer
        Dim T As String
        ' Get Reference for loaded style
        K = Val(Scintilla1.Lexing.StyleNameMap.Values(J).ToString)
        ' get the Style Name
        Dim StyleName As String = Scintilla1.Lexing.StyleNameMap.Keys(J).ToString
        ' Style properties
        'Dim StyleFontName As String = Scintilla1.Styles(K).FontName.ToString
        'Dim StyleCharSet As String = Scintilla1.Styles(K).CharacterSet.ToString
        'Dim StyleFontSize As String = Scintilla1.Styles(K).Size.ToString
        Dim StyleFontBold As String = Scintilla1.Styles(K).Bold.ToString
        Dim StyleFontItalic As String = Scintilla1.Styles(K).Italic.ToString
        Dim StyleFontUnder As String = Scintilla1.Styles(K).Underline.ToString
        Dim StyleFontCase As String = Scintilla1.Styles(K).Case.ToString
        Dim StyleVisible As String = Scintilla1.Styles(K).IsVisible.ToString
        Dim StyleEolFill As String = Scintilla1.Styles(K).IsSelectionEolFilled.ToString

        'T = "<Style Name=" & QStr(StyleName) & " FontName=" & QStr(StyleFontName) & " FontSize=" & QStr(StyleFontSize) & _
        T = "<Style Name=" & QStr(StyleName) & _
            " Bold=" & QStr(StyleFontBold) & " Italic=" & QStr(StyleFontItalic) & " UnderLine=" & QStr(StyleFontUnder) & _
            " EolFilled=" & QStr(StyleEolFill) & " ForeColor=" & QStr(RtnColorStr(K)) & " BackColor=" & QStr(RtnColorStr(K, 1)) & " />"
        ' Added Feature to build Tab delimited string ... (Two blank fileds are included after Style Name for Notes adn Sample)
        TabStr = K.ToString & vbTab & StyleName & vbTab & vbTab & vbTab & RtnColorStr(K, 1) & vbTab & RtnColorStr(K, 0) & vbTab & _
                 StyleFontBold & vbTab & StyleFontItalic & vbTab & StyleFontUnder & vbTab & StyleEolFill

        Return T
    End Function
    Private Function QStr(Q As String) As String
        Return Chr(34) & Q & Chr(34)
    End Function
    Private Function RtnColorStr(ByVal StyleNo As Integer, Optional ByVal ForeOrBack As Integer = 0) As String
        ' 0 for Fore Ground anything else for Background
        Dim StyleColor As String
        Dim StyleNumb As Int32
        If ForeOrBack = 0 Then
            StyleColor = Scintilla1.Styles(StyleNo).ForeColor.ToString
            StyleNumb = Scintilla1.Styles(StyleNo).ForeColor.ToArgb
        Else
            StyleColor = Scintilla1.Styles(StyleNo).BackColor.ToString
            StyleNumb = Scintilla1.Styles(StyleNo).BackColor.ToArgb
        End If
        ' Colors are a bit of a problem. we First need to strip "Color[" & "]" off the ends
        ' Samples: Color [A=0, R=15, G=250, B=170] or Color [Window] or Color [Green]
        ' Use Mid because the flakey Microsoft IDE will not let us use Left.
        StyleColor = Mid(StyleColor, 8)
        StyleColor = Trim(Mid(StyleColor, 1, Len(StyleColor) - 1))
        ' If the string begins with "A=" then we have to convert it from AARRGGBB to RRGGBB in the form ForeColor="#ff00ff"
        ' Basically I am ignoring the Alpha channel
        If InStr(StyleColor, "A=") > 0 Then StyleColor = "#" & Microsoft.VisualBasic.Right("000000" & Hex(StyleNumb), 6)
        If StyleColor = "#FFFFFF" Then StyleColor = "White"
        If StyleColor = "#000000" Then StyleColor = "Black"
        Return StyleColor

    End Function

    Private Sub Button9_Click(sender As System.Object, e As System.EventArgs) Handles Button9.Click
        Scintilla1.Lexing.LexerName = "SQL"
        'Scintilla1.NativeInterface.SetLexer(7)
        'Scintilla1.NativeInterface.
        UpdateLaguage()
    End Sub

    Private Sub Button10_Click(sender As System.Object, e As System.EventArgs) Handles Button10.Click
        Scintilla1.Lexing.LexerName = "MSSQL"
        'Scintilla1.NativeInterface.SetLexer(55)
        UpdateLaguage()
    End Sub
    Private Sub Button12_Click(sender As System.Object, e As System.EventArgs) Handles Button12.Click
        Scintilla1.Lexing.LexerName = "Progress"
        'Scintilla1.NativeInterface.SetLexer(83)
        UpdateLaguage()
    End Sub

    Private Sub Button11_Click(sender As System.Object, e As System.EventArgs) Handles Button11.Click
        ' Next Style -------
        Dim T As String = ""
        Dim S As String = ""
        Dim L As Integer = 0

        Static Dim N As Integer = 0
        Static Dim LastFontBack As System.Drawing.Color = Color.White
        Static Dim LastFontName As String = FnameDefault
        Static Dim LastLexer As String = ""
        Static Dim StyleNumbers() As Integer
        Static Dim StyleNames() As String

        If ListView1.Visible Then ShowStyles()

        ' Has the anything changed (most particullaryly the Lexer) ??
        If (Scintilla1.Lexing.LexerName <> LastLexer) Or (TextBox1.Text = "") Then
            LastLexer = Scintilla1.Lexing.LexerName
            TextBox1.Text = ""
            ' Now Colect the Style Numbers
            N = Scintilla1.Lexing.StyleNameMap.Count
            ReDim StyleNumbers(0 To N - 1)
            ReDim StyleNames(0 To N - 1)
            N = 0
            For Each Z In Scintilla1.Lexing.StyleNameMap
                StyleNumbers(N) = Z.Value
                StyleNames(N) = Z.Key
                If Scintilla1.Styles(StyleNumbers(N)).FontName = "Arial Black" Then
                    Scintilla1.Styles(StyleNumbers(N)).FontName = LastFontName
                    Scintilla1.Styles(StyleNumbers(N)).BackColor = LastFontBack
                End If
                N = N + 1
            Next
        End If

        ' Restore our current font ... this is the thrid time I am rewriting this because
        ' Microsoft's user hostile IDE erased the origonal code during its reformatting frenzy.
        If TextBox1.Text <> "" Then
            L = Val(TextBox1.Text)
            Scintilla1.Styles(L).FontName = LastFontName
            Scintilla1.Styles(L).BackColor = LastFontBack
        End If

        ' We want to set N to the Next Style number but only valid styles for this Lexer
        N = N + 1
        If N >= Scintilla1.Lexing.StyleNameMap.Count Then N = 0
        L = StyleNumbers(N)
        ' Store our current Style
        LastFontBack = Scintilla1.Styles(L).BackColor
        LastFontName = Scintilla1.Styles(L).FontName
        ' Now we can change it
        Scintilla1.Styles(L).FontName = "Arial Black" ' "Segoe Print"
        Scintilla1.Styles(L).BackColor = Color.Yellow
        TextBox1.Text = L.ToString
        Label1.Text = StyleNames(N)
        Label1.Visible = True
        TextBox1.Visible = True

    End Sub

    
End Class
